//------------------------------------------------------------------
//                             nonlag_ma_histo_mtfalerts-2_nmc.mq4   
//------------------------------------------------------------------
#property link      "http://newdigital-world.com/forum.php"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrRed
#property indicator_width1  4
#property indicator_width2  4
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

input string   TimeFrame       = "Current time frame";
input int      NlmPeriod       = 25;
input int      NlmMode         = MODE_LWMA;
input int      NlmPrice        = PRICE_CLOSE;
input double   PctFilter       = 0;
input int      Shift           = 0;

input bool     alertsOn        = false;
input bool     alertsOnCurrent = true;
input bool     alertsMessage   = true;
input bool     alertsSound     = false;
input bool     alertsEmail     = false;

input string   arrows          = "=== Arrows ===";
input bool     showArrows      =    false;       
input int      arrowSize       =       15;
input string   arrowFontName   = "Wingdings";
input int      arrowBuyCode    =      233;
input int      arrowSellCode   =      234;
input color	   upArrowColor    = clrDeepSkyBlue;
input color	   dnArrowColor    = clrRed;

input string   lines           = "=== Lines ===";
input bool     showLines       =    false;
input int      lineStyle       =        0;
input int      lineWidth       =        0;
input color	   upLineColor     = clrDeepSkyBlue;
input color	   dnLineColor     = clrRed;
input string	uniqueName      = "nonlag";
//
//
//
//
//

double UpH[];
double DnH[];
double trend[];
double nlm[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,UpH);    SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,DnH);    SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,nlm);    SetIndexShift(2,Shift);
   SetIndexBuffer(3,trend);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
         SetIndexShift(2,Shift * timeFrame/Period());  
      
      //
      //
      //
      //
      //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" nonlag Ma ("+NlmPeriod+")");
   return(0);
}

int deinit()
{
   deleteObj(uniqueName);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][2];
#define _change 0
#define _achang 1
int start()
{
   int i,r,counted_bars=IndicatorCounted();
   bool   upsignal,dnsignal;
   double gap;
   string dnarrow_name,uparrow_name,dnline_name,upline_name; 
   
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { UpH[0] = MathMin(limit+1,Bars-1); return(0); }
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
     for (i=limit, r=Bars-i-1; i>=0; i--,r++)
     {
         nlm[i]   = iNonLagMa(iMA(NULL,0,1,0,NlmMode,NlmPrice,i),NlmPeriod,i,0);
         UpH[i]   = EMPTY_VALUE;
         DnH[i]   = EMPTY_VALUE;
         trend[i] = trend[i+1];

         //
         //
         //
         //
         //
               
         if (PctFilter>0)
         {
            work[r][_change] = MathAbs(nlm[i]-nlm[i+1]);
            work[r][_achang] = work[r][_change];
            for (int k=1; k<NlmPeriod; k++) work[r][_achang] += work[r-k][_change];
                                            work[r][_achang] /= 1.0*NlmPeriod;
    
            double stddev = 0; for (k=0; k<NlmPeriod; k++) stddev += MathPow(work[r-k][_change]-work[r-k][_achang],2);
                   stddev = MathSqrt(stddev/NlmPeriod); 
            double filter = PctFilter * stddev;
            if( MathAbs(nlm[i]-nlm[i+1]) < filter ) nlm[i]=nlm[i+1];
         }

         //
         //
         //
         //
         //
               
         if (nlm[i]>nlm[i+1]) trend[i] =  1;
         if (nlm[i]<nlm[i+1]) trend[i] = -1;
         if (trend[i] == 1)   UpH[i] = 1;
         if (trend[i] ==-1)   DnH[i] = 1;
         
         if(showArrows || showLines)
         {
         upsignal = trend[i] > 0 && trend[i+1] <= 0;
         dnsignal = trend[i] < 0 && trend[i+1] >= 0;
            
            if(showArrows)
            {
            gap = 0.5*MathCeil(iATR(NULL,0,14,i)/Point);
			
		      dnarrow_name = uniqueName + "_DnArrow_" + TimeToStr(Time[i]);
            uparrow_name = uniqueName + "_UpArrow_" + TimeToStr(Time[i]);
      
            if(i == 0) {ObjectDelete(dnarrow_name); ObjectDelete(uparrow_name);}
		
		      if(upsignal) drawArrow(uparrow_name,Time[i],NormalizeDouble(Low[i] - gap*Point,Digits),arrowFontName,arrowSize,CharToStr(arrowBuyCode ),upArrowColor,ANCHOR_UPPER);
		      if(dnsignal) drawArrow(dnarrow_name,Time[i],NormalizeDouble(High[i]+ gap*Point,Digits),arrowFontName,arrowSize,CharToStr(arrowSellCode),dnArrowColor,ANCHOR_LOWER);
            }
            
            if(showLines)
            {
            dnline_name = uniqueName + "_DnLine_" + TimeToStr(Time[i]);
            upline_name = uniqueName + "_UpLine_" + TimeToStr(Time[i]);
      
            if(i == 0) {ObjectDelete(dnline_name); ObjectDelete(upline_name);}
		
		      if(upsignal) drawLine(upline_name,Time[i],lineStyle,lineWidth,upLineColor);
		      if(dnsignal) drawLine(dnline_name,Time[i],lineStyle,lineWidth,dnLineColor);
            }
         }
      }
   manageAlerts();
   return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NlmPeriod,NlmMode,NlmPrice,PctFilter,Shift,3,y);
            UpH[i]   = EMPTY_VALUE;
            DnH[i]   = EMPTY_VALUE;
            if (trend[i] == 1) UpH[i] = 1;
            if (trend[i] ==-1) DnH[i] = 1;
            
         if(showArrows || showLines)
         {
         double prevtrend = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NlmPeriod,NlmMode,NlmPrice,PctFilter,Shift,3,y+1);
            
         
         upsignal = trend[i] > 0 && prevtrend <= 0;
         dnsignal = trend[i] < 0 && prevtrend >= 0;
            
            if(showArrows)
            {
            gap = 0.5*MathCeil(iATR(NULL,timeFrame,14,y)/Point);
			
		      dnarrow_name = uniqueName + "_DnArrow_" + TimeToStr(Time[i]);
            uparrow_name = uniqueName + "_UpArrow_" + TimeToStr(Time[i]);
      
            if(y == 0) {ObjectDelete(dnarrow_name); ObjectDelete(uparrow_name);}
		
		      if(upsignal) drawArrow(uparrow_name,Time[i],NormalizeDouble(iLow (NULL,timeFrame,y) - gap*Point,Digits),arrowFontName,arrowSize,CharToStr(arrowBuyCode ),upArrowColor,ANCHOR_UPPER);
		      if(dnsignal) drawArrow(dnarrow_name,Time[i],NormalizeDouble(iHigh(NULL,timeFrame,y) + gap*Point,Digits),arrowFontName,arrowSize,CharToStr(arrowSellCode),dnArrowColor,ANCHOR_LOWER);
            }
            
            if(showLines)
            {
            dnline_name = uniqueName + "_DnLine_" + TimeToStr(Time[i]);
            upline_name = uniqueName + "_UpLine_" + TimeToStr(Time[i]);
      
            if(y == 0) {ObjectDelete(dnline_name); ObjectDelete(upline_name);}
		
		      if(upsignal) drawLine(upline_name,Time[i],lineStyle,lineWidth,upLineColor);
		      if(dnsignal) drawLine(dnline_name,Time[i],lineStyle,lineWidth,dnLineColor);
            }
         }
      }
 manageAlerts();
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1

double  nlmvalues[][2];
double  nlmprices[][1];
double  nlmalphas[][1];

//
//
//
//
//

double iNonLagMa(double price, double length, int r, int instanceNo=0)
{
   r = Bars-r-1;
   if (ArrayRange(nlmprices,0) != Bars)         ArrayResize(nlmprices,Bars);
   if (ArrayRange(nlmvalues,0) <  instanceNo+1) ArrayResize(nlmvalues,instanceNo+1);
                               nlmprices[r][instanceNo]=price;
   if (length<3 || r<3) return(nlmprices[r][instanceNo]);
   
   //
   //
   //
   //
   //
   
   if (nlmvalues[instanceNo][_length] != length  || ArraySize(nlmalphas)==0)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
         nlmvalues[instanceNo][_length] = length;
         nlmvalues[instanceNo][_len   ] = length*4 + Phase;  

         if (ArrayRange(nlmalphas,0) < nlmvalues[instanceNo][_len]) ArrayResize(nlmalphas,nlmvalues[instanceNo][_len]);
         for (int k=0; k<nlmvalues[instanceNo][_len]; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            nlmalphas[k][instanceNo] = g * beta;
         }
   }
   
   //
   //
   //
   //
   //
   
    double sum = 0, sumw = 0;
        for (k=0; k < nlmvalues[instanceNo][_len] && (r-k)>=0; k++) { sum += nlmalphas[k][instanceNo]*nlmprices[r-k][instanceNo]; sumw += nlmalphas[k][instanceNo]; }
        if (sumw!=0)
             return(sum/sumw);
        else return(price);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," nonlag ma changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," nonlag ma "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

bool deleteObj(string name)
{
   bool result = false;
   
   int length = StringLen(name);
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
   string objName = ObjectName(i); 
   if(StringSubstr(objName,0,length) == name) {ObjectDelete(objName); result = true;}
   }
   
   return(result);
}

void drawArrow(string name,int time,double price,string font,int size,string acode,color clr,int anchor)
{
   ObjectCreate(name,OBJ_TEXT,0,time, price);
   ObjectSetText(name,acode,size,font,clr); 
   ObjectSet(name,OBJPROP_ANCHOR,anchor);
}	                                  

void drawLine(string name,int time,int style,int width,color clr)
{
   ObjectCreate(name,OBJ_VLINE,0,time,0);
   ObjectSet(name,OBJPROP_COLOR,  clr);
   ObjectSet(name,OBJPROP_STYLE,style);
   ObjectSet(name,OBJPROP_WIDTH,width);
}	                                  
